Index: drivers/serial/21285.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/serial/21285.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/serial/21285.c	22 Jul 2004 19:50:26 -0000	1.1
+++ drivers/serial/21285.c	4 Aug 2004 01:29:43 -0000	1.2
@@ -5,7 +5,7 @@
  *
  * Based on drivers/char/serial.c
  *
- *  $Id: 21285.c,v 1.1 2004/07/22 19:50:26 joff Exp $
+ *  $Id: 21285.c,v 1.2 2004/08/04 01:29:43 joff Exp $
  */
 #include <linux/config.h>
 #include <linux/module.h>
@@ -32,11 +32,17 @@
 
 #define BAUD_BASE		(mem_fclk_21285/64)
 
+#ifdef CONFIG_DEVFS_FS
+#define SERIAL_21285_NAME	"tts/FB%d"
+#define SERIAL_21285_AUXNAME	"cua/FB%d"
+#else
 #define SERIAL_21285_NAME	"ttyFB"
+#define SERIAL_21285_AUXNAME	"cuafb"
+#endif
+
 #define SERIAL_21285_MAJOR	204
 #define SERIAL_21285_MINOR	4
 
-#define SERIAL_21285_AUXNAME	"cuafb"
 #define SERIAL_21285_AUXMAJOR	205
 #define SERIAL_21285_AUXMINOR	4
 
@@ -479,21 +485,14 @@
 	int baud = 9600;
 	int bits = 8;
 	int parity = 'n';
+	int flow;
 	int cflag = CREAD | HUPCL | CLOCAL;
 
 	if (machine_is_personal_server())
 		baud = 57600;
 
-	if (options) {
-		char *s = options;
-		baud = simple_strtoul(options, NULL, 10);
-		while (*s >= '0' && *s <= '9')
-			s++;
-		if (*s)
-			parity = *s++;
-		if (*s)
-			bits = *s - '0';
-	}
+	if (options)
+		uart_parse_options(options, &baud, &parity, &bits, &flow);
 
 	/*
 	 *    Now construct a cflag setting.
Index: drivers/serial/8250.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/serial/8250.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/serial/8250.c	22 Jul 2004 19:50:26 -0000	1.1
+++ drivers/serial/8250.c	4 Aug 2004 01:29:43 -0000	1.2
@@ -12,7 +12,7 @@
  * the Free Software Foundation; either version 2 of the License, or
  * (at your option) any later version.
  *
- *  $Id: 8250.c,v 1.1 2004/07/22 19:50:26 joff Exp $
+ *  $Id: 8250.c,v 1.2 2004/08/04 01:29:43 joff Exp $
  *
  * A note about mapbase / membase
  *
Index: drivers/serial/8250.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/serial/8250.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/serial/8250.h	22 Jul 2004 19:50:26 -0000	1.1
+++ drivers/serial/8250.h	4 Aug 2004 01:29:43 -0000	1.2
@@ -12,7 +12,7 @@
  * the Free Software Foundation; either version 2 of the License, or
  * (at your option) any later version.
  *
- *  $Id: 8250.h,v 1.1 2004/07/22 19:50:26 joff Exp $
+ *  $Id: 8250.h,v 1.2 2004/08/04 01:29:43 joff Exp $
  */
 
 #include <linux/config.h>
Index: drivers/serial/8250_pci.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/serial/8250_pci.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/serial/8250_pci.c	22 Jul 2004 19:50:26 -0000	1.1
+++ drivers/serial/8250_pci.c	4 Aug 2004 01:29:43 -0000	1.2
@@ -11,7 +11,7 @@
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation; either version 2 of the License.
  *
- *  $Id: 8250_pci.c,v 1.1 2004/07/22 19:50:26 joff Exp $
+ *  $Id: 8250_pci.c,v 1.2 2004/08/04 01:29:43 joff Exp $
  */
 #include <linux/config.h>
 #include <linux/module.h>
Index: drivers/serial/8250_pnp.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/serial/8250_pnp.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/serial/8250_pnp.c	22 Jul 2004 19:50:26 -0000	1.1
+++ drivers/serial/8250_pnp.c	4 Aug 2004 01:29:43 -0000	1.2
@@ -11,7 +11,7 @@
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation; either version 2 of the License.
  *
- *  $Id: 8250_pnp.c,v 1.1 2004/07/22 19:50:26 joff Exp $
+ *  $Id: 8250_pnp.c,v 1.2 2004/08/04 01:29:43 joff Exp $
  */
 #include <linux/config.h>
 #include <linux/module.h>
Index: drivers/serial/Config.in
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/serial/Config.in,v
retrieving revision 1.1
retrieving revision 1.10
diff -u -r1.1 -r1.10
--- drivers/serial/Config.in	22 Jul 2004 19:50:26 -0000	1.1
+++ drivers/serial/Config.in	15 Feb 2007 19:25:06 -0000	1.10
@@ -1,7 +1,7 @@
 #
 # Serial device configuration
 #
-# $Id: Config.in,v 1.1 2004/07/22 19:50:26 joff Exp $
+# $Id: Config.in,v 1.10 2007/02/15 19:25:06 eddie Exp $
 #
 mainmenu_option next_comment
 comment 'Serial drivers'
@@ -25,6 +25,17 @@
   fi
   fi
 
+  tristate 'Core support for TS-UARTs' CONFIG_SERIAL_TSUART
+  tristate 'Support for TS-7260 TS-UARTs' CONFIG_SERIAL_TSUART7260
+  tristate 'Support for TS-7300 TS-UARTs' CONFIG_SERIAL_TSUART73
+  tristate 'Support for TS-940 TS-UARTs' CONFIG_SERIAL_TSUART940
+  tristate 'Support for TS-BAT3 TS-UARTs' CONFIG_SERIAL_TSUART3BAT
+  tristate 'Support for TS-PAC4 TS-UARTs' CONFIG_SERIAL_TSUART4PAC
+  tristate 'Support for TS-7400 TS-UARTs' CONFIG_SERIAL_TSUART7400
+  tristate 'Support for TS-RF2 TS-UARTs' CONFIG_SERIAL_TSUARTRF2
+  tristate 'Support for BOC-EDWARDS TS-UARTs' CONFIG_SERIAL_TSUARTBOC
+  tristate 'Support for TS-733 TS-UARTs' CONFIG_SERIAL_TS733
+
 # EP93xx AMBA serial port
   if [ "$CONFIG_ARCH_EP9301" = "y" -o \
        "$CONFIG_ARCH_EP9312" = "y" -o \
Index: drivers/serial/Makefile
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/serial/Makefile,v
retrieving revision 1.1
retrieving revision 1.11
diff -u -r1.1 -r1.11
--- drivers/serial/Makefile	22 Jul 2004 19:50:26 -0000	1.1
+++ drivers/serial/Makefile	15 Feb 2007 19:25:17 -0000	1.11
@@ -8,12 +8,12 @@
 # Note 2! The CFLAGS definitions are now inherited from the
 # parent makes..
 #
-#  $Id: Makefile,v 1.1 2004/07/22 19:50:26 joff Exp $
+#  $Id: Makefile,v 1.11 2007/02/15 19:25:17 eddie Exp $
 #
 
 O_TARGET := serial.o
 
-export-objs	:= core.o 8250.o
+export-objs	:= core.o 8250.o tsuart0.o
 obj-y		:=
 obj-m		:=
 obj-n		:=
@@ -33,6 +33,16 @@
 obj-$(CONFIG_SERIAL_UART00) += uart00.o
 obj-$(CONFIG_SERIAL_OMAHA) += omaha.o
 obj-$(CONFIG_SERIAL_AT91US3) += at91us3.o
+obj-$(CONFIG_SERIAL_TSUART) += tsuart0.o
+obj-$(CONFIG_SERIAL_TSUART73) += tsuart-73.o
+obj-$(CONFIG_SERIAL_TSUART7260) += tsuart7260.o
+obj-$(CONFIG_SERIAL_TSUART940) += tsuart940.o
+obj-$(CONFIG_SERIAL_TSUART3BAT) += tsuart-bat3.o
+obj-$(CONFIG_SERIAL_TSUART4PAC) += tsuart-pac4.o
+obj-$(CONFIG_SERIAL_TSUART7400) += tsuart7400.o
+obj-$(CONFIG_SERIAL_TSUARTRF2) += tsuart-rf.o
+obj-$(CONFIG_SERIAL_TSUARTBOC) += tsuart-boc.o
+obj-$(CONFIG_SERIAL_TS733) += tsuart-733.o
 
 include $(TOPDIR)/Rules.make
 
Index: drivers/serial/amba.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/serial/amba.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/serial/amba.c	22 Jul 2004 19:50:26 -0000	1.1
+++ drivers/serial/amba.c	4 Aug 2004 01:29:44 -0000	1.2
@@ -22,7 +22,7 @@
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  *
- *  $Id: amba.c,v 1.1 2004/07/22 19:50:26 joff Exp $
+ *  $Id: amba.c,v 1.2 2004/08/04 01:29:44 joff Exp $
  *
  * This is a generic driver for ARM AMBA-type serial ports.  They
  * have a lot of 16550-like features, but are not register compatable.
Index: drivers/serial/anakin.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/serial/anakin.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/serial/anakin.c	22 Jul 2004 19:50:26 -0000	1.1
+++ drivers/serial/anakin.c	4 Aug 2004 01:29:44 -0000	1.2
@@ -19,7 +19,7 @@
  *   			SA_INTERRUPT. Works reliably now. No longer requires
  *   			changes to the serial_core API.
  *
- *  $Id: anakin.c,v 1.1 2004/07/22 19:50:26 joff Exp $
+ *  $Id: anakin.c,v 1.2 2004/08/04 01:29:44 joff Exp $
  */
 
 #include <linux/config.h>
Index: drivers/serial/clps711x.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/serial/clps711x.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/serial/clps711x.c	22 Jul 2004 19:50:26 -0000	1.1
+++ drivers/serial/clps711x.c	4 Aug 2004 01:29:44 -0000	1.2
@@ -22,7 +22,7 @@
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  *
- *  $Id: clps711x.c,v 1.1 2004/07/22 19:50:26 joff Exp $
+ *  $Id: clps711x.c,v 1.2 2004/08/04 01:29:44 joff Exp $
  *
  */
 #include <linux/config.h>
Index: drivers/serial/core.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/serial/core.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/serial/core.c	22 Jul 2004 19:50:26 -0000	1.1
+++ drivers/serial/core.c	4 Aug 2004 01:29:44 -0000	1.2
@@ -22,7 +22,7 @@
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  *
- *  $Id: core.c,v 1.1 2004/07/22 19:50:26 joff Exp $
+ *  $Id: core.c,v 1.2 2004/08/04 01:29:44 joff Exp $
  *
  */
 #include <linux/config.h>
@@ -1117,6 +1117,10 @@
 				clear = ~val;
 				break;
 			}
+
+			set &= TIOCM_DTR|TIOCM_RTS|TIOCM_OUT1|TIOCM_OUT2|TIOCM_LOOP;
+			clear &= TIOCM_DTR|TIOCM_RTS|TIOCM_OUT1|TIOCM_OUT2|TIOCM_LOOP;
+
 			ret = uart_tiocmset(tty, filp, set, clear);
 		}
 		break;
Index: drivers/serial/ep93xx_amba.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/serial/ep93xx_amba.c,v
retrieving revision 1.1
retrieving revision 1.22
diff -u -r1.1 -r1.22
--- drivers/serial/ep93xx_amba.c	22 Jul 2004 19:50:26 -0000	1.1
+++ drivers/serial/ep93xx_amba.c	8 Feb 2007 15:27:14 -0000	1.22
@@ -24,7 +24,7 @@
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  *
- *  $Id: ep93xx_amba.c,v 1.1 2004/07/22 19:50:26 joff Exp $
+ *  $Id: ep93xx_amba.c,v 1.22 2007/02/08 15:27:14 michael Exp $
  *
  * The EP9312 serial ports are AMBA, but at different addresses from the
  * integrator.
@@ -47,8 +47,11 @@
 
 #include <asm/hardware.h>
 #include <asm/io.h>
+#include "ts7412.h"
 #include <asm/irq.h>
 
+#define DELAY_TIMEX HZ
+
 #if defined(CONFIG_SERIAL_AMBA_CONSOLE) && defined(CONFIG_MAGIC_SYSRQ)
 #define SUPPORT_SYSRQ
 #endif
@@ -57,6 +60,8 @@
 
 #include <asm/hardware/serial_amba.h>
 
+#include <linux/ts_sbc.h>
+
 #if !defined(CONFIG_EP93XX_IRDA)
 #define UART_NR		3
 #else
@@ -72,9 +77,15 @@
 #define CALLOUT_AMBA_MINOR	16
 #define CALLOUT_AMBA_NR		UART_NR
 
+static struct timer_list timer = { .function = NULL }, timer0 = { .function = NULL };
 static struct tty_driver normal, callout;
 static struct tty_struct *cs_amba_table[UART_NR];
 static struct termios *cs_amba_termios[UART_NR], *cs_amba_termios_locked[UART_NR];
+static struct uart_amba_port amba_ports[];
+
+static int ts7200_uart_get_fr (struct uart_port *) ;
+static void ts7200_uart_set_mcr (struct uart_port *, unsigned ) ;
+
 #ifdef SUPPORT_SYSRQ
 static struct console cs_amba_console;
 #endif
@@ -86,10 +97,12 @@
  */
 #define UART_GET_INT_STATUS(p)	((readl((p)->membase + AMBA_UARTIIR)) & 0xff)
 #define UART_PUT_ICR(p, c)		writel((c), (p)->membase + AMBA_UARTICR)
-#define UART_GET_FR(p)			((readl((p)->membase + AMBA_UARTFR)) & 0xff)
+//#define UART_GET_FR(p)			((readl((p)->membase + AMBA_UARTFR)) & 0xff)
+#define UART_GET_FR(p)			(ts7200_uart_get_fr(p))
 #define UART_GET_CHAR(p)		((readl((p)->membase + AMBA_UARTDR)) & 0xff)
 #define UART_PUT_CHAR(p, c)		writel((c), (p)->membase + AMBA_UARTDR)
 #define UART_GET_RSR(p)			((readl((p)->membase + AMBA_UARTRSR)) & 0xff)
+#define UART_PUT_RSR(p,c)		writel((c), (p)->membase + AMBA_UARTRSR)
 #define UART_GET_CR(p)			((readl((p)->membase + AMBA_UARTCR)) & 0xff)
 #define UART_PUT_CR(p,c)		writel((c), (p)->membase + AMBA_UARTCR)
 #define UART_GET_LCRL(p)		((readl((p)->membase + AMBA_UARTLCR_L)) & 0xff)
@@ -102,12 +115,14 @@
 #define UART_TX_READY(s)		(((s) & AMBA_UARTFR_TXFF) == 0)
 #define UART_TX_EMPTY(p)		((UART_GET_FR(p) & AMBA_UARTFR_TMSK) == 0)
 
-#define UART_PUT_MCR(c, p)  writel((c), (p)->membase + ((unsigned int)UART1MCR & 0xffff))
+#define UART_PUT_MCR(c, p)  (ts7200_uart_set_mcr(p,c))
+//#define UART_PUT_MCR(c, p)  writel((c), (p)->membase + ((unsigned int)UART1MCR & 0xffff))
+
 #define UART_CLEAR_ECR(p)   writel( 0, (p)->membase + AMBA_UARTECR)
 
 #define UART_DUMMY_RSR_RX	256
 #define UART_PORT_SIZE		64
-
+
 /*
  * Our private driver data mappings.
  */
@@ -123,6 +138,87 @@
 	unsigned int		old_status;
 };
 
+static int ts7200_auto485 (struct uart_port *port, unsigned int cmd, unsigned long * arg)
+{
+	int baud, cflag, mode;
+	int datalength ; //datalength + parenb
+	struct sbc_info *sbc;
+
+	mode = *arg;
+	sbc = get_sbcinfo();
+	if (!sbc->auto485) {
+		remove_sbcinfo(sbc);
+		printk("ep93xx_amba.c: sorry, this board does not support auto485\n");
+		printk("check /proc/SBC/info for features supported\n");
+		return -1;
+	}
+
+	remove_sbcinfo(sbc);
+
+	datalength = 8;
+	cflag = port->info->tty->termios->c_cflag ;
+	if (cflag & PARENB)
+		datalength++;
+
+	if (cflag & CSTOPB)
+		datalength++;
+
+	baud = tty_get_baud_rate (port->info->tty);
+
+	switch (cmd) {
+		case TIOC_SBCC485:
+			if ((mode & AUTO485FD) || (mode & AUTO485HD)) {
+				printk("unsetting automode\n");
+				outw(0, TS7XXX_RS485CTRL);
+				outw(0, TS7XXX_RS485DATA9);
+			}
+			break;
+		case TIOC_SBCS485:
+			if (mode & AUTO485FD) {
+				printk ("setting FULL duplex\n");
+				outw(0x01, TS7XXX_RS485CTRL);
+				if (datalength > 8)
+					outw(0x01, TS7XXX_RS485DATA9); 
+			} else if (mode & AUTO485HD) {
+				printk("setting HALF DUPLEX\n");
+				switch (baud) {
+					case 9600:
+						outw(0x04, TS7XXX_RS485CTRL);
+						break;
+					case 19200:
+						outw(0x05, TS7XXX_RS485CTRL);
+						break;
+					case 57600:
+						outw(0x06, TS7XXX_RS485CTRL);
+						break;
+					case 115200:
+						outw(0x07, TS7XXX_RS485CTRL);
+						break;
+					default:
+					printk("auto485.c: %d Baud Rate is not supported for auto RS485 mode\n", baud);
+					return -1;
+				}
+				if (datalength > 8)
+					outw(0x01, TS7XXX_RS485DATA9); 
+			}
+			break;
+	}
+
+	return 0;
+}
+static int ep93xxamba_ioctls (struct uart_port *port, unsigned int cmd, unsigned long arg)
+{
+	switch (cmd) {
+		case TIOC_SBCC485:
+		case TIOC_SBCS485:
+			return ts7200_auto485 (port,cmd, (unsigned long *)arg);
+			break;
+		default:
+			return -ENOIOCTLCMD;
+	}
+
+	return -ENOIOCTLCMD;
+}
 
 static void csambauart_enable_clocks(struct uart_port *port)
 {
@@ -294,12 +390,21 @@
 
 			rsr &= port->read_status_mask;
 
-			if (rsr & AMBA_UARTRSR_BE)
+			/* According to the EP9315 Users Guide, to clear 
+			 * any overrun, break, parity or framing error, you 
+			 * have to write to the UART RSR register. */
+			if (rsr & AMBA_UARTRSR_BE){
 				*tty->flip.flag_buf_ptr = TTY_BREAK;
-			else if (rsr & AMBA_UARTRSR_PE)
+				UART_PUT_RSR(port, AMBA_UARTRSR_BE);
+			}
+			else if (rsr & AMBA_UARTRSR_PE){
 				*tty->flip.flag_buf_ptr = TTY_PARITY;
-			else if (rsr & AMBA_UARTRSR_FE)
+				UART_PUT_RSR(port, AMBA_UARTRSR_PE);
+			}
+			else if (rsr & AMBA_UARTRSR_FE){
 				*tty->flip.flag_buf_ptr = TTY_FRAME;
+				UART_PUT_RSR(port, AMBA_UARTRSR_FE);
+			}
 		}
 
 		if (uart_handle_sysrq_char(port, ch, regs))
@@ -320,6 +425,8 @@
 			*tty->flip.char_buf_ptr++ = 0;
 			*tty->flip.flag_buf_ptr++ = TTY_OVERRUN;
 			tty->flip.count++;
+			
+			UART_PUT_RSR(port, AMBA_UARTRSR_OE);
 		}
 	ignore_char:
 		status = UART_GET_FR(port);
@@ -387,6 +494,18 @@
 	wake_up_interruptible(&uap->port.info->delta_msr_wait);
 }
 
+static void csambauart_dcd_timer(unsigned long data) {
+  disable_irq(IRQ_UART1);
+  disable_irq(IRQ_UART2);
+  disable_irq(IRQ_UART3);
+  csambauart_modem_status((struct uart_port *)data);
+  enable_irq(IRQ_UART3);
+  enable_irq(IRQ_UART2);
+  enable_irq(IRQ_UART1);
+  timer.expires = jiffies + DELAY_TIMEX;
+  add_timer (&timer);
+}
+
 static void csambauart_int(int irq, void *dev_id, struct pt_regs *regs)
 {
 	struct uart_port *port = dev_id;
@@ -436,20 +555,23 @@
 
 static void csambauart_set_mctrl(struct uart_port *port, unsigned int mctrl)
 {
-	struct uart_amba_port *uap = (struct uart_amba_port *)port;
-	unsigned int ctrl = 0;
+  struct uart_amba_port *uap = (struct uart_amba_port *)port;
+  int rts_mask = gpio ? 2 : uap->rts_mask; // override default non-existence of RTS/DTR when 7412 used.
+  int dtr_mask = gpio ? 1 : uap->dtr_mask; // yech! this is awful...
+  unsigned int ctrl = rts_mask | dtr_mask;
 	
-	/* If there's no RTS and DTR for this UART, do nothing here */
-	if(	(uap->rts_mask == 0) && (uap->dtr_mask == 0) )
-		return;
+  /* If there's no RTS and DTR for this UART, do nothing here */
+  if( (rts_mask == 0) && (dtr_mask == 0) )
+    return;
   
-    if ((mctrl & TIOCM_RTS) == 0)
-		ctrl |= uap->rts_mask;
-	
-    if ((mctrl & TIOCM_DTR) == 0)
-		ctrl |= uap->dtr_mask;
-    
-	UART_PUT_MCR(ctrl, port);
+  if ((mctrl & TIOCM_RTS) == 0)
+    ctrl &= ~rts_mask;
+  
+  if ((mctrl & TIOCM_DTR) == 0) {
+    ctrl &= ~dtr_mask;
+  }
+  
+  UART_PUT_MCR(ctrl, port);
 }
 
 static void csambauart_break_ctl(struct uart_port *port, int break_state)
@@ -471,7 +593,7 @@
 {
 	struct uart_amba_port *uap = (struct uart_amba_port *)port;
     int retval;
-
+
     csambauart_enable_clocks(port);
 
 	/*
@@ -492,26 +614,36 @@
 	UART_PUT_CR(port, AMBA_UARTCR_UARTEN | AMBA_UARTCR_RIE |
 			  AMBA_UARTCR_RTIE);
 
+	if (timer.function == NULL && port == (struct uart_port *)amba_ports) {
+	  timer.expires = jiffies + DELAY_TIMEX;
+	  timer.data = (unsigned long )port;
+	  timer.function = csambauart_dcd_timer;
+	  add_timer (&timer);
+	}
 	return 0;
 }
 
 static void csambauart_shutdown(struct uart_port *port)
 {
-	/*
-	 * Free the interrupt
-	 */
-	free_irq(port->irq, port);
-
-	/*
-	 * disable all interrupts, disable the port
-	 */
-	UART_PUT_CR(port, 0);
-
-	/* disable break condition and fifos */
-	UART_PUT_LCRH(port, UART_GET_LCRH(port) &
-		~(AMBA_UARTLCR_H_BRK | AMBA_UARTLCR_H_FEN));
-
-	csambauart_disable_clocks( port );
+  if (port == (struct uart_port *)amba_ports) {
+      del_timer (&timer);
+      timer.function = NULL;
+  }
+      /*
+       * Free the interrupt
+       */
+      free_irq(port->irq, port);
+      
+      /*
+       * disable all interrupts, disable the port
+       */
+      UART_PUT_CR(port, 0);
+  
+      /* disable break condition and fifos */
+      UART_PUT_LCRH(port, UART_GET_LCRH(port) &
+		    ~(AMBA_UARTLCR_H_BRK | AMBA_UARTLCR_H_FEN));
+      
+      csambauart_disable_clocks( port );
 }
 static void csambauart_change_speed(struct uart_port *port, unsigned int cflag, unsigned int iflag, unsigned int quot)
 {
@@ -686,6 +818,7 @@
 	.request_port	= csambauart_request_port,
 	.config_port	= csambauart_config_port,
 	.verify_port	= csambauart_verify_port,
+	.ioctl		= ep93xxamba_ioctls,
 };
 
 static struct uart_amba_port amba_ports[UART_NR] = {
@@ -742,6 +875,59 @@
 	}
 };
 
+/*
+ * We need to support DCD changes, however, our hardware doesn't 
+ * have DCD hooked up the typical way on COM1, hence, the following 
+ * hack
+ * 	-- L.A.Y, Technologic Systems 08/2004
+ *
+ * The TS-7412 board requires that we use DIO pins for our COM1 and COM2
+ * flow control signals.  Added ts7200_uart_set_mcr and modified the
+ * existing ts7200_uart_get_fr to accomodate this.
+ *      -- M 11/13/2006
+ */
+static int ts7200_uart_get_fr (struct uart_port *port) {
+	volatile unsigned long uart_fr ;
+	unsigned short dcd_status;
+	int port1 = (port->membase != amba_ports[0].port.membase) ? 1 : 0;
+
+	if (gpio) {
+	  uart_fr = (readl(port->membase + AMBA_UARTFR) ) & 0xff ;
+          uart_fr |= AMBA_UARTFR_DSR; // NOT TIOCM_DSR!!!
+	  if (mdmctrl1_dcd_get(port1)) {
+	    uart_fr |= AMBA_UARTFR_DCD; // NOT TIOCM_CAR!!!
+    	  }
+	  if (mdmctrl1_cts_get(port1)) {
+	    uart_fr |= AMBA_UARTFR_CTS; // NOT TIOCM_CTS !!!
+	  }
+	  return uart_fr;
+	}
+
+	if (port1 == 1)
+	  return ( (readl(port->membase + AMBA_UARTFR) ) & 0xff );
+
+	uart_fr = (readl(port->membase + AMBA_UARTFR) ) & 0xff ;
+	dcd_status = (inb(TS7XXX_IO8_BASE + 0x00800000)) & 0x40;
+
+	if (dcd_status) // dcd_status is active low
+		uart_fr &= ~AMBA_UARTFR_DCD;
+	else
+		uart_fr |= AMBA_UARTFR_DCD;
+
+	return uart_fr;
+}
+
+static void ts7200_uart_set_mcr (struct uart_port *p, unsigned c) {
+  int port1 = (p->membase != amba_ports[0].port.membase) ? 1 : 0;
+
+  if (gpio) {
+    mdmctrl1_dtr_set(port1,((c & 1) /* & TIOCM_DTR */)?1:0);
+    mdmctrl1_rts_set(port1,((c & 2) /*& TIOCM_RTS */)?1:0);
+  } else {
+    writel((c), (p)->membase + ((unsigned int)UART1MCR & 0xffff));
+  }
+}
+	
 #ifdef CONFIG_SERIAL_AMBA_CONSOLE
 
 static void csambauart_console_write(struct console *co, const char *s, unsigned int count)
@@ -869,7 +1055,13 @@
 
 void __init ambauart_console_init(void)
 {
-	register_console(&cs_amba_console);
+#ifdef TS7412_UNSAFE_DETECTION
+  timer0.expires = jiffies + HZ;
+  timer0.data = 0;
+  timer0.function = ts7412_detect_test;
+  add_timer (&timer0);
+#endif
+  register_console(&cs_amba_console);
 }
 
 #define AMBA_CONSOLE	&cs_amba_console
@@ -930,3 +1122,168 @@
 MODULE_AUTHOR("ARM Ltd/Deep Blue Solutions Ltd/Cirrus Logic, Inc.");
 MODULE_DESCRIPTION("EP9312 ARM AMBA serial port driver");
 MODULE_LICENSE("GPL");
+
+/*
+  All our TS-7412 specific stuff goes here.
+ */
+char *gpio = 0;
+
+static void gpio_dir_set(int pin,int output) {
+  if (!gpio) {
+    return;
+  }
+  if (pin > 7) {
+    pin -= 8;
+    if (output) {
+      gpio[1] |= (1 << pin);
+    } else {
+      gpio[1] &= ~(1 << pin);
+    }
+  } else {
+    if (output) {
+      gpio[0] |= (1 << pin);
+    } else {
+      gpio[0] &= ~(1 << pin);
+    }
+  }
+}
+
+static int gpio_data_get(int pin) {
+  if (!gpio) {
+    return 0;
+  }
+  if (pin > 7) {
+    pin -= 8;
+    return (gpio[3] >> pin) & 1;
+  } else {
+    return (gpio[2] >> pin) & 1;
+  }
+}
+
+static void gpio_data_set(int pin,int value) {
+  if (!gpio) {
+    return;
+  }
+  if (pin > 7) {
+    pin -= 8;
+    if (value) {
+      gpio[3] |= (1 << pin);
+    } else {
+      gpio[3] &= ~(1 << pin);
+    }
+  } else {
+    if (value) {
+      gpio[2] |= (1 << pin);
+    } else {
+      gpio[2] &= ~(1 << pin);
+    }
+  }
+}
+
+void mdmctrl_rts_set(int val) {
+  gpio_dir_set(10,1);
+  gpio_data_set(10,val?0:1);
+  //printk("RTS3=%d\n",val?0:1);
+}
+void mdmctrl_dtr_set(int val) {
+  gpio_dir_set(9,1);
+  gpio_data_set(9,val?0:1);
+  //printk("DTR3=%d\n",val?0:1);
+}
+int mdmctrl_cts_get(void) {
+  gpio_dir_set(5,1);
+  gpio_data_set(5,1);
+  //printk("CTS3==%d\n",gpio_data_get(2)?0:1);
+  return gpio_data_get(2)?0:1;
+}
+int mdmctrl_dcd_get(void) {
+  gpio_dir_set(5,1);
+  gpio_data_set(5,1);
+  //printk("DCD3==%d\n",gpio_data_get(3)?0:1);
+  return gpio_data_get(3)?0:1;
+}
+
+void mdmctrl1_rts_set(int port,int val) {
+  gpio_dir_set(port?14:12,1);
+  gpio_data_set(port?14:12,val?0:1);
+  //printk("RTS1 %d=%d\n",port,val?0:1);
+}
+void mdmctrl1_dtr_set(int port,int val) {
+  gpio_dir_set(port?13:11,1);
+  gpio_data_set(port?13:11,val?0:1);
+  //printk("DTR1 %d=%d\n",port,val?0:1);
+}
+int mdmctrl1_cts_get(int port) {
+  int ret;
+
+  gpio_dir_set(5,1);
+  gpio_data_set(5,port?0:1);
+  ret = gpio_data_get(0)?0:1;
+  //printk("CTS1 %d==%d\n",port,ret);
+  return ret;
+}
+int mdmctrl1_dcd_get(int port) {
+  int ret;
+
+  gpio_dir_set(5,1);
+  gpio_data_set(5,port?0:1);
+  ret = gpio_data_get(1)?0:1;
+  //printk("DCD1 %d==%d\n",port,ret);
+  return  ret;
+}
+
+int ts7412_detect_test(unsigned long data) {
+  char *ctrl = 0;
+  if (gpio == 0) {
+    gpio = (char *)__ioremap(0x12c00000,4096,0);
+    if (gpio == 0) {
+      printk(KERN_ERR "tsuart7400: cannot io map gpio\n");
+      return 0;
+    }
+    gpio_dir_set(5,1);
+    gpio_dir_set(6,1);
+    gpio_dir_set(14,1);
+    gpio_dir_set(3,0);
+    gpio_data_set(5,0);  // SEL
+    gpio_data_set(6,0);  // RD_257A#
+    gpio_data_set(14,0); // RTS1#
+    if (gpio_data_get(3) != 0) {
+      //printk("7412 test failed at 1\n");
+      __iounmap(gpio);
+      gpio = 0;
+      goto detect_7412_done;
+    }
+    gpio_data_set(14,1); // RTS1#
+    if (gpio_data_get(3) != 1) {
+      //printk("7412 test failed at 2\n");
+      __iounmap(gpio);
+      gpio = 0;
+      goto detect_7412_done;
+    }
+    gpio_data_set(5,1);  // RD_257A#
+    gpio_data_set(14,gpio_data_get(3)?0:1);
+    if (gpio_data_get(14) == gpio_data_get(3)) {
+      //printk("7412 test failed at 3.1\n");
+      __iounmap(gpio);
+      gpio = 0;
+      goto detect_7412_done;
+    }
+  }
+  ctrl = (char *)__ioremap(0x12000000,4096,0);
+  if (ctrl == 0) {
+    printk(KERN_ERR "ts7412 detection: cannot io map ctrl\n");
+    __iounmap(gpio);
+    gpio = 0;
+    return 0;
+  }
+  *ctrl |= 1;
+  //  printk("CTRL=%02X\n",*ctrl);
+  __iounmap(ctrl);
+ detect_7412_done:
+  if (gpio) {
+    printk("EP93XX_AMBA detected a TS-7400 with TS-7412 present\n");
+  } else {
+    //printk("EP93XX_AMBA did NOT detect a TS-7412.\n");
+  }
+  return (gpio != 0);
+}
Index: drivers/serial/omaha.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/serial/omaha.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/serial/omaha.c	22 Jul 2004 19:50:26 -0000	1.1
+++ drivers/serial/omaha.c	4 Aug 2004 01:29:44 -0000	1.2
@@ -22,7 +22,7 @@
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  *
- *  $Id: omaha.c,v 1.1 2004/07/22 19:50:26 joff Exp $
+ *  $Id: omaha.c,v 1.2 2004/08/04 01:29:44 joff Exp $
  *
  * This is a generic driver for ARM AMBA-type serial ports.  They
  * have a lot of 16550-like features, but are not register compatable.
Index: drivers/serial/sa1100.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/serial/sa1100.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/serial/sa1100.c	22 Jul 2004 19:50:26 -0000	1.1
+++ drivers/serial/sa1100.c	4 Aug 2004 01:29:44 -0000	1.2
@@ -21,7 +21,7 @@
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  *
- *  $Id: sa1100.c,v 1.1 2004/07/22 19:50:26 joff Exp $
+ *  $Id: sa1100.c,v 1.2 2004/08/04 01:29:44 joff Exp $
  *
  */
 #include <linux/config.h>
Index: drivers/serial/ts7412.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/serial/ts7412.h,v
retrieving revision 1.1
retrieving revision 1.5
diff -u -r1.1 -r1.5
--- drivers/serial/ts7412.h	5 Dec 2006 00:14:05 -0000	1.1
+++ drivers/serial/ts7412.h	31 Jan 2007 22:38:09 -0000	1.5
@@ -1,127 +1,18 @@
-/*
-  I hate putting code in .h files, but in this case it seemed to make sense,
-  so as to avoid code duplication between the tsuart7400.c driver and the
-  ep93xx_amba.c driver.  I definitely didn't want to create a new module
-  dependency just for these functions...
-    --M
- */
-#ifdef TS7412_SLAVE
 extern char *gpio;
+
+int ts7412_detect_test(unsigned long);
+
+void mdmctrl_rts_set(int val);
+void mdmctrl_dtr_set(int val);
+int mdmctrl_cts_get(void);
+int mdmctrl_dcd_get(void);
+
 void mdmctrl1_rts_set(int port,int val);
 void mdmctrl1_dtr_set(int port,int val);
 int mdmctrl1_cts_get(int port);
 int mdmctrl1_dcd_get(int port);
-#define _TS7412_H
-#endif
-
-#ifndef _TS7412_H
-#define _TS7412_H
-char *gpio = 0;
-
-static void gpio_dir_set(int pin,int output) {
-  if (!gpio) {
-    return;
-  }
-  if (pin > 7) {
-    pin -= 8;
-    if (output) {
-      gpio[1] |= (1 << pin);
-    } else {
-      gpio[1] &= ~(1 << pin);
-    }
-  } else {
-    if (output) {
-      gpio[0] |= (1 << pin);
-    } else {
-      gpio[0] &= ~(1 << pin);
-    }
-  }
-}
-
-static int gpio_data_get(int pin) {
-  if (!gpio) {
-    return 0;
-  }
-  if (pin > 7) {
-    pin -= 8;
-    return (gpio[3] >> pin) & 1;
-  } else {
-    return (gpio[2] >> pin) & 1;
-  }
-}
-
-static void gpio_data_set(int pin,int value) {
-  if (!gpio) {
-    return;
-  }
-  if (pin > 7) {
-    pin -= 8;
-    if (value) {
-      gpio[3] |= (1 << pin);
-    } else {
-      gpio[3] &= ~(1 << pin);
-    }
-  } else {
-    if (value) {
-      gpio[2] |= (1 << pin);
-    } else {
-      gpio[2] &= ~(1 << pin);
-    }
-  }
-}
-
-void mdmctrl_rts_set(int val) {
-  gpio_dir_set(10,1);
-  gpio_data_set(10,val?0:1);
-  //printk("RTS3=%d\n",val?0:1);
-}
-void mdmctrl_dtr_set(int val) {
-  gpio_dir_set(9,1);
-  gpio_data_set(9,val?0:1);
-  //printk("DTR3=%d\n",val?0:1);
-}
-int mdmctrl_cts_get(void) {
-  gpio_dir_set(5,1);
-  gpio_data_set(5,1);
-  //printk("CTS3==%d\n",gpio_data_get(2)?0:1);
-  return gpio_data_get(2)?0:1;
-}
-int mdmctrl_dcd_get(void) {
-  gpio_dir_set(5,1);
-  gpio_data_set(5,1);
-  //printk("DCD3==%d\n",gpio_data_get(3)?0:1);
-  return gpio_data_get(3)?0:1;
-}
-
-void mdmctrl1_rts_set(int port,int val) {
-  gpio_dir_set(port?14:12,1);
-  gpio_data_set(port?14:12,val?0:1);
-  printk("RTS1 %d=%d\n",port,val?0:1);
-}
-void mdmctrl1_dtr_set(int port,int val) {
-  gpio_dir_set(port?13:11,1);
-  gpio_data_set(port?13:11,val?0:1);
-  printk("DTR1 %d=%d\n",port,val?0:1);
-}
-int mdmctrl1_cts_get(int port) {
-  int ret;
-
-  gpio_dir_set(5,1);
-  gpio_data_set(5,port?0:1);
-  ret = gpio_data_get(0)?0:1;
-  printk("CTS1 %d==%d\n",port,ret);
-  return ret;
-}
-int mdmctrl1_dcd_get(int port) {
-  int ret;
-
-  gpio_dir_set(5,1);
-  gpio_data_set(5,port?0:1);
-  ret = gpio_data_get(1)?0:1;
-  printk("DCD1 %d==%d\n",port,ret);
-  return  ret;
-}
 
+/*
 void led1(unsigned *test,int on) {
   if (on) {
     test[0] = test[0] | 1;
@@ -137,6 +28,8 @@
     test[0] = test[0] & 0xFFFFFFFD;
   }
 }
+*/
+
   /*
   unsigned *test = __ioremap(0x80840020,4096,0);
 
@@ -161,54 +54,3 @@
   return 0;
   */
 
-static char * ts7412_detect_test(void) {
-  char *ctrl = 0;
-  if (gpio == 0) {
-    gpio = (char *)__ioremap(0x12c00000,4096,0);
-    if (gpio == 0) {
-      printk(KERN_ERR "tsuart7400: cannot io map gpio\n");
-      return 0;
-    }
-    gpio_dir_set(5,1);
-    gpio_dir_set(6,1);
-    gpio_dir_set(14,1);
-    gpio_dir_set(3,0);
-    gpio_data_set(5,0);  // SEL
-    gpio_data_set(6,0);  // RD_257A#
-    gpio_data_set(14,0); // RTS1#
-    if (gpio_data_get(3) != 0) {
-      //printk("7412 test failed at 1\n");
-      __iounmap(gpio);
-      gpio = 0;
-      return 0;
-    }
-    gpio_data_set(14,1); // RTS1#
-    if (gpio_data_get(3) != 1) {
-      //printk("7412 test failed at 2\n");
-      __iounmap(gpio);
-      gpio = 0;
-      return 0;
-    }
-    gpio_data_set(5,1);  // RD_257A#
-    gpio_data_set(14,gpio_data_get(3)?0:1);
-    if (gpio_data_get(14) == gpio_data_get(3)) {
-      //printk("7412 test failed at 3.1\n");
-      __iounmap(gpio);
-      gpio = 0;
-      return 0;
-    }
-  }
-  ctrl = (char *)__ioremap(0x12000000,4096,0);
-  if (ctrl == 0) {
-    printk(KERN_ERR "tsuart7400: cannot io map ctrl\n");
-    __iounmap(gpio);
-    gpio = 0;
-    return 0;
-  }
-  *ctrl |= 1;
-  //  printk("CTRL=%02X\n",*ctrl);
-  __iounmap(ctrl);
-  return gpio;
-}
-#endif
-
